module memory(read_data, read_address, write_data, write_address, 
			  memwrite, clock, reset);
	output [7:0] read_data;
	input [2:0]read_address;
	input [7:0]write_data;
	input [2:0]write_address;
	input memwrite;
	input clock;
	input reset;
	reg [7:0] read_data, mem0, mem1;
	
		/* Block for memory read */
	always @(read_address or mem0 or mem1)
	begin
		case(read_address)
			3'b 000: read_data = mem0;
			3'b 001: read_data = mem1;
		/* Unimplemented memory */
			default: read_data = 8'h FF;
		endcase
	end
	
		/* Block for memory write */
	always @(posedge clock or posedge reset)
	begin
		if (reset)
		 	begin
		/* Initial values for memory (optional) */
				mem0 = 8'h AA ;
				mem1 = 8'h 55;
			end
		else if (memwrite)
			case (write_address)
				3'b 000 : mem0 = write_data;
				3'b 001 : mem1 = write_data;
			endcase
	end
endmodule
